/* ******************************************* */
/* WorkflowGen v5.3                            */
/* Update script for 5.2         		       */
/* January 16th 2011                           */
/* ******************************************* */

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

/*  IMP# 2871  */

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFACTIVITY_INST'
	AND COLUMN_NAME = 'MSG_THREAD_INDEX')
ALTER TABLE [WFACTIVITY_INST] ADD [MSG_THREAD_INDEX] [nvarchar] (32) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO

/*  IMP# 2972  */

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFRELDATA'
	AND COLUMN_NAME = 'FORMAT_STRING')
ALTER TABLE [WFRELDATA] ADD [FORMAT_STRING] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFRELDATA'
	AND COLUMN_NAME = 'FORMAT_CULTURE')
ALTER TABLE [WFRELDATA] ADD [FORMAT_CULTURE] [nvarchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFRELDATA'
	AND COLUMN_NAME = 'FORMAT_PRECISION')
ALTER TABLE [WFRELDATA] ADD [FORMAT_PRECISION] [int] NULL
GO

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFRELDATA'
	AND COLUMN_NAME = 'FORMAT_TIMEZONE')
ALTER TABLE [WFRELDATA] ADD [FORMAT_TIMEZONE] [int] NULL
GO

/*  IMP# 2304  */

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'USERS_VIEWS'
	AND COLUMN_NAME = 'SHARED')
ALTER TABLE [USERS_VIEWS] ADD [SHARED] [nvarchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO

If Not EXISTS (
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'USERS_VIEWS_MAPTO')
BEGIN
	CREATE TABLE [USERS_VIEWS_MAPTO] (
		[ID_USER] [int] NOT NULL,
		[NUM_VIEW] [int] NOT NULL,
		[ID_PARTICIPANT] [int] NOT NULL
		) 
		ON [PRIMARY]

	ALTER TABLE [USERS_VIEWS_MAPTO] ADD 
		CONSTRAINT [PK_USERS_VIEWS_MAPTO] 
		PRIMARY KEY CLUSTERED ([ID_USER], [NUM_VIEW], [ID_PARTICIPANT])
		ON [PRIMARY] 
		
	ALTER TABLE [USERS_VIEWS_MAPTO]  WITH CHECK ADD  
		CONSTRAINT [FK_USERS_VIEWS_MAPTO_REFERENCE_USERS_VIEWS] FOREIGN KEY([ID_USER], [NUM_VIEW])
		REFERENCES [USERS_VIEWS] ([ID_USER], [NUM_VIEW])
		ON DELETE CASCADE

	ALTER TABLE [USERS_VIEWS_MAPTO] CHECK 
		CONSTRAINT [FK_USERS_VIEWS_MAPTO_REFERENCE_USERS_VIEWS]

	ALTER TABLE [USERS_VIEWS_MAPTO]  WITH CHECK ADD  
		CONSTRAINT [FK_USERS_VIEWS_MAPTO_REFERENCE_WFPARTICIPANT] FOREIGN KEY([ID_PARTICIPANT])
		REFERENCES [WFPARTICIPANT] ([ID_PARTICIPANT])
		ON DELETE CASCADE

	ALTER TABLE [USERS_VIEWS_MAPTO] CHECK 
		CONSTRAINT [FK_USERS_VIEWS_MAPTO_REFERENCE_WFPARTICIPANT]
END
GO
