/* ******************************************* */
/* WorkflowGen v5.5.2                          */
/* Update script for 5.5.1                     */
/* 10/12/2012                                  */
/* ******************************************* */

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

/*  IMP# 3211  */

IF NOT EXISTS (SELECT [name] FROM sysindexes WHERE [name] = 'DIRNAME' OR [name] = 'GROUPS_ID_DIRECTORY')
BEGIN

	CREATE  UNIQUE  INDEX [DIRNAME] ON [DIRECTORY]([DIRNAME]) ON [PRIMARY]

	CREATE  INDEX [GROUPS_ID_DIRECTORY] ON [GROUPS]([ID_DIRECTORY]) ON [PRIMARY]
	CREATE  INDEX [GROUPNAME] ON [GROUPS]([GROUPNAME]) ON [PRIMARY]

	CREATE  INDEX [USERS_ID_DIRECTORY] ON [USERS]([ID_DIRECTORY]) ON [PRIMARY]
	CREATE  UNIQUE  INDEX [USERNAME] ON [USERS]([USERNAME]) ON [PRIMARY]
	CREATE  INDEX [LASTNAME] ON [USERS]([LASTNAME]) ON [PRIMARY]

	CREATE  INDEX [USERS_GROUPS_ID_GROUP] ON [USERS_GROUPS]([ID_GROUP]) ON [PRIMARY]
	CREATE  INDEX [USERS_GROUPS_ID_USER] ON [USERS_GROUPS]([ID_USER]) ON [PRIMARY]

	CREATE  INDEX [ID_PROFILE_USERS_PROFILE] ON [USERS_PROFILE]([ID_PROFILE]) ON [PRIMARY]
	CREATE  INDEX [ID_USER_USERS_PROFILE] ON [USERS_PROFILE]([ID_USER]) ON [PRIMARY]

	CREATE  INDEX [WFAPPLICATIONWFPROCESS_ACTIVIT] ON [WFACTIVITY]([ID_APPLICATION]) ON [PRIMARY]
	CREATE  INDEX [WFDURATION_UNITWFPROCESS_ACTIV] ON [WFACTIVITY]([ID_DURATION_UNIT]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_ACTIVITY_ASSIGN_TYPE] ON [WFACTIVITY]([ID_ASSIGN_TYPE]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_ACTIVITY_TYPEWFPROCE] ON [WFACTIVITY]([ID_ACTIVITY_TYPE]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFPROCESS_ACTIVITY] ON [WFACTIVITY]([ID_PROCESS]) ON [PRIMARY]
	CREATE  INDEX [REFERENCE_30_FK] ON [WFACTIVITY]([ID_PARTICIPANT]) ON [PRIMARY]
	CREATE  INDEX [REFERENCE_62_FK] ON [WFACTIVITY]([ID_PROCESS_ASSIGN], [ID_RELDATA_ASSIGN]) ON [PRIMARY]

	CREATE  INDEX [USERSWFACTIVITY_INST] ON [WFACTIVITY_INST]([ID_USER_ASSIGNEE]) ON [PRIMARY]
	CREATE  INDEX [USERSWFACTIVITY_INST1] ON [WFACTIVITY_INST]([ID_USER_ASSIGNED_BY]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_ACTIVITYWFACTIVITY_I] ON [WFACTIVITY_INST]([ID_PROCESS], [ID_ACTIVITY]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_INSTWFACTIVITY_INST] ON [WFACTIVITY_INST]([ID_PROCESS_INST]) ON [PRIMARY]
	CREATE  INDEX [WFSUBSTATEWFACTIVITY_INST] ON [WFACTIVITY_INST]([ID_STATE], [ID_SUBSTATE]) ON [PRIMARY]
	CREATE  INDEX [DATELIMITWFACTIVITY_INST] ON [WFACTIVITY_INST]([ID_STATE], [DATE_LIMIT]) ON [PRIMARY]
	CREATE  INDEX [REFERENCE_59_FK] ON [WFACTIVITY_INST]([ID_USER_REQUESTER]) ON [PRIMARY]

	CREATE  INDEX [WFACTIVITY_INSTWFACTIVITY_INST] ON [WFACTIVITY_INST_RELDATA]([ID_PROCESS_INST], [ID_ACTIVITY_INST]) ON [PRIMARY]
	CREATE  INDEX [WFDATASETWFACTIVITY_INST_REVDA] ON [WFACTIVITY_INST_RELDATA]([ID_DATASET]) ON [PRIMARY]
	CREATE  INDEX [WFREVDATAWFACTIVITY_INST_REVDA] ON [WFACTIVITY_INST_RELDATA]([ID_RELDATA]) ON [PRIMARY]

	CREATE  INDEX [NUM_NOTIFY2] ON [WFACTIVITY_NOTIFY]([MAPTO]) ON [PRIMARY]
	CREATE  INDEX [NUM_NOTIFY1] ON [WFACTIVITY_NOTIFY]([NUM_NOTIFY]) ON [PRIMARY]
	CREATE  INDEX [WFPARTICIPANTWFPROCESS_TRANSIT] ON [WFACTIVITY_NOTIFY]([ID_PARTICIPANT]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_ACTIVITYWFPROCESS_AC] ON [WFACTIVITY_NOTIFY]([ID_PROCESS], [ID_ACTIVITY]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_ACTIVITYWFPROCESS_T2] ON [WFACTIVITY_NOTIFY]([ID_PROCESS_NOTIFY], [ID_ACTIVITY_NOTIFY]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_TRANSITION_NOTIFYID_] ON [WFACTIVITY_NOTIFY]([ID_PROCESS]) ON [PRIMARY]

	CREATE  INDEX [ACTIVITY_PARAM_PROCESS_ACTIVITY] ON [WFACTIVITY_PARAM]([ID_PROCESS], [ID_ACTIVITY]) ON [PRIMARY]
	CREATE  INDEX [WFRELDATAWFPROCESS_ACTIVITY_RE] ON [WFACTIVITY_PARAM]([ID_RELDATA]) ON [PRIMARY]

	CREATE  INDEX [WFAPPLICATION_TYPEWFAPPLICATIO] ON [WFAPPLICATION]([ID_APP_TYPE]) ON [PRIMARY]
	CREATE  UNIQUE  INDEX [APPLICATION_NAME] ON [WFAPPLICATION]([NAME]) ON [PRIMARY]

	CREATE  INDEX [NUM_PARAM] ON [WFAPPLICATION_PARAM]([NUM_PARAM]) ON [PRIMARY]
	CREATE  INDEX [WFAPPLICATIONWFAPPLICATION_PAR] ON [WFAPPLICATION_PARAM]([ID_APPLICATION]) ON [PRIMARY]
	CREATE  INDEX [WFDATATYPEWFAPPLICATION_PARAM] ON [WFAPPLICATION_PARAM]([ID_DATATYPE]) ON [PRIMARY]

	CREATE  UNIQUE  INDEX [CATEGORY_NAME] ON [WFCATEGORY]([NAME]) ON [PRIMARY]

	CREATE  INDEX [WFDATATYPEWFDATASET] ON [WFDATASET]([ID_DATATYPE]) ON [PRIMARY]

	CREATE  INDEX [WFDATASETWFDATASET_VALUE] ON [WFDATASET_VALUE]([ID_DATASET]) ON [PRIMARY]

	CREATE  INDEX [IDUSER_WFDELEGATE] ON [WFDELEGATE]([ID_USER]) ON [PRIMARY]
	CREATE  INDEX [IDUSERDELEGATE_WFDELEGATE] ON [WFDELEGATE]([ID_USER_DELEGATE]) ON [PRIMARY]
	CREATE  INDEX [PROCESSPARTICIPANT_WFDELEGATE] ON [WFDELEGATE]([ID_PROCESS], [ID_PARTICIPANT]) ON [PRIMARY]
	CREATE  INDEX [DATES_WFDELEGATE] ON [WFDELEGATE]([ID_USER], [DATE_BEGIN], [DATE_END]) ON [PRIMARY]

	CREATE  INDEX [WFFOLDERWFFOLDER] ON [WFFOLDER]([ID_FOLDER_PARENT]) ON [PRIMARY]

	CREATE  INDEX [WFFOLDERWFFOLDER_PERM] ON [WFFOLDER_PERM]([ID_FOLDER]) ON [PRIMARY]
	CREATE  INDEX [WFPARTICIPANTWFFOLDER_PERM] ON [WFFOLDER_PERM]([ID_PARTICIPANT]) ON [PRIMARY]
	CREATE  INDEX [WFPERM_TYPEWFFOLDER_PERM] ON [WFFOLDER_PERM]([ID_PERM_TYPE]) ON [PRIMARY]

	CREATE  INDEX [WFPARTICIPANT_TYPEWFPARTICIPAN] ON [WFPARTICIPANT]([ID_PARTICIPANT_TYPE]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFPARTICIPANT] ON [WFPARTICIPANT]([ID_PROCESS]) ON [PRIMARY]

	CREATE  INDEX [DIRECTORYWFPARTICIPANT_MAPTO] ON [WFPARTICIPANT_MAPTO]([ID_DIRECTORY]) ON [PRIMARY]
	CREATE  INDEX [GROUPSWFPARTICIPANT_MAPTO] ON [WFPARTICIPANT_MAPTO]([ID_GROUP]) ON [PRIMARY]
	CREATE  INDEX [NUM_MAPTO] ON [WFPARTICIPANT_MAPTO]([NUM_MAPTO]) ON [PRIMARY]
	CREATE  INDEX [USERSWFPARTICIPANT_MAPTO] ON [WFPARTICIPANT_MAPTO]([ID_USER]) ON [PRIMARY]
	CREATE  INDEX [WFPARTICIPANTWFPARTICIPANT_MAP] ON [WFPARTICIPANT_MAPTO]([ID_PARTICIPANT]) ON [PRIMARY]

	CREATE  INDEX [USERSWFPROCESS] ON [WFPROCESS]([ID_USER_UPDATE]) ON [PRIMARY]
	CREATE  INDEX [USERSWFPROCESS1] ON [WFPROCESS]([ID_USER_CREATION]) ON [PRIMARY]
	CREATE  INDEX [WFDURATION_UNITWFPROCESS] ON [WFPROCESS]([ID_DURATION_UNIT]) ON [PRIMARY]
	CREATE  INDEX [WFFOLDERWFPROCESS] ON [WFPROCESS]([ID_FOLDER]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_STATUSWFPROCESS] ON [WFPROCESS]([ID_PROCESS_STATUS]) ON [PRIMARY]
	CREATE  UNIQUE  INDEX [NAME_VERSION] ON [WFPROCESS]([NAME], [VERSION]) ON [PRIMARY]

	CREATE  INDEX [WFCATEGORYWFPROCESS_CATEGORY] ON [WFPROCESS_CATEGORY]([ID_CATEGORY]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFPROCESS_CATEGORY] ON [WFPROCESS_CATEGORY]([ID_PROCESS]) ON [PRIMARY]

	CREATE  INDEX [NUM_WFPROCESS_INST] ON [WFPROCESS_INST]([ID_PROCESS_INST]) ON [PRIMARY]
	CREATE  INDEX [USERSWFPROCESS_INST] ON [WFPROCESS_INST]([ID_USER_REQUESTER]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFPROCESS_INST] ON [WFPROCESS_INST]([ID_PROCESS]) ON [PRIMARY]
	CREATE  INDEX [WFSUBSTATEWFPROCESS_INST] ON [WFPROCESS_INST]([ID_STATE], [ID_SUBSTATE]) ON [PRIMARY]
	CREATE  INDEX [DATELIMITWFPROCESS_INST] ON [WFPROCESS_INST]([ID_STATE], [DATE_LIMIT]) ON [PRIMARY]
	CREATE  UNIQUE  INDEX [NAME] ON [WFPROCESS_INST]([NAME]) ON [PRIMARY]

	CREATE  INDEX [USERSWFPROCESS_INST_RELDATA] ON [WFPROCESS_INST_RELDATA]([ID_USER_LOCK_BY]) ON [PRIMARY]
	CREATE  INDEX [WFDATASETWFPROCESS_INST_REVDAT] ON [WFPROCESS_INST_RELDATA]([ID_DATASET]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_INSTWFPROCESS_INST_R] ON [WFPROCESS_INST_RELDATA]([ID_PROCESS_INST]) ON [PRIMARY]
	CREATE  INDEX [WFREVDATAWFPROCESS_INST_REVDAT] ON [WFPROCESS_INST_RELDATA]([ID_RELDATA]) ON [PRIMARY]

	IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'WFPROCESS_INST_COMMENT')
	BEGIN
	
		IF NOT EXISTS (SELECT [name] FROM sysindexes WHERE [name] = 'NUM_WFPROCESS_INST_COMMENT')
		BEGIN
	
			CREATE INDEX [NUM_WFPROCESS_INST_COMMENT] ON [WFPROCESS_INST_COMMENT]([NUM_COMMENT]) ON [PRIMARY]
			CREATE INDEX [USERS_WFPROCESS_INST_COMMENT] ON [WFPROCESS_INST_COMMENT]([ID_USER_AUTHOR]) ON [PRIMARY]
			CREATE INDEX [ID_WFPROCESS_INST_COMMENT] ON [WFPROCESS_INST_COMMENT]([ID_PROCESS_INST]) ON [PRIMARY]
			
		END
		
	END

	CREATE  INDEX [WFPARTICIPANT_ROLEWFPROCESS_PA] ON [WFPROCESS_PARTICIPANT]([ID_PARTICIPANT_ROLE]) ON [PRIMARY]
	CREATE  INDEX [WFPARTICIPANTWFPROCESS_PARTICI] ON [WFPROCESS_PARTICIPANT]([ID_PARTICIPANT]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFPROCESS_PARTICIPANT] ON [WFPROCESS_PARTICIPANT]([ID_PROCESS]) ON [PRIMARY]

	CREATE  INDEX [WFDATASETWFPROCESS_REVDATA] ON [WFPROCESS_RELDATA]([ID_DATASET_DEFAULT]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFPROCESS_REVDATA] ON [WFPROCESS_RELDATA]([ID_PROCESS]) ON [PRIMARY]
	CREATE  INDEX [WFREVDATAWFPROCESS_REVDATA] ON [WFPROCESS_RELDATA]([ID_RELDATA]) ON [PRIMARY]

	CREATE  INDEX [WFPARTICIPANTWFPROCESS_RELDATA] ON [WFPROCESS_RELDATA_RESTRICT]([ID_PARTICIPANT]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_RELDATAWFPROCESS_REL] ON [WFPROCESS_RELDATA_RESTRICT]([ID_PROCESS], [ID_RELDATA]) ON [PRIMARY]

	CREATE  INDEX [NUM_TRANS] ON [WFPROCESS_TRANSITION]([ID_TRANSITION]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESS_ACTIVITYWFPROCESS_TR] ON [WFPROCESS_TRANSITION]([ID_PROCESS], [ID_ACTIVITY_FROM]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFPROCESS_TRANSITION] ON [WFPROCESS_TRANSITION]([ID_PROCESS]) ON [PRIMARY]
	CREATE  INDEX [REFERENCE_48_FK] ON [WFPROCESS_TRANSITION]([ID_PROCESS_FROM], [ID_ACTIVITY_FROM]) ON [PRIMARY]
	CREATE  INDEX [REFERENCE_49_FK] ON [WFPROCESS_TRANSITION]([ID_PROCESS_TO], [ID_ACTIVITY_TO]) ON [PRIMARY]

	CREATE  INDEX [WFDATATYPEWFREVDATA] ON [WFRELDATA]([ID_DATATYPE]) ON [PRIMARY]
	CREATE  INDEX [WFPROCESSWFREVDATA] ON [WFRELDATA]([ID_PROCESS]) ON [PRIMARY]

	CREATE  INDEX [WFSTATEWFSUBSTATE] ON [WFSUBSTATE]([ID_STATE]) ON [PRIMARY]
	
END
GO