/* ******************************************* */
/* WorkflowGen v5.6.0                          */
/* Update script for 5.5.5                     */
/* 04/10/2014                                  */
/* ******************************************* */

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

/*  IMP# 3286  */

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFACTIVITY'
	AND COLUMN_NAME = 'COMPLETE_ASYNC')
ALTER TABLE [WFACTIVITY] ADD [COMPLETE_ASYNC] [nvarchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO


/*  IMP# 3173  */

CREATE TABLE [dbo].[WFLIST](
	[ID_LIST] [int] NOT NULL,
	[NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	[ID_PARTICIPANT] [int] NULL,
	[DATE_UPDATE] [datetime] NOT NULL,
	[ID_USER_UPDATE] [int] NULL,
	[NB_ITEMS] [int] NOT NULL,
	[FIELD1_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD1_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD2_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD2_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD3_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD3_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD4_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD4_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD5_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD5_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD6_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD6_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD7_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD7_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD8_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD8_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD9_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD9_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD10_NAME] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD10_TYPE] [nvarchar](50) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELDS_ALL_NAME] [nvarchar](max) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[CONNECTION_MODE] [nvarchar](64) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[CONNECTION_NAME] [nvarchar](64) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[CONNECTION_STRING] [nvarchar](500) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[PROVIDER_NAME] [nvarchar](64) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[SELECT_COMMAND] [nvarchar](max) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
) ON [PRIMARY]
GO


CREATE TABLE [dbo].[WFLIST_ITEMS](
	[ID_LIST] [int] NOT NULL,
	[LANGUAGE] [nvarchar](7) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	[DISP_ORDER] [int] NOT NULL,
	[FIELD1_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD1_NUMERIC] [float] NULL,
	[FIELD1_DATE] [datetime] NULL,
	[FIELD2_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD2_NUMERIC] [float] NULL,
	[FIELD2_DATE] [datetime] NULL,
	[FIELD3_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD3_NUMERIC] [float] NULL,
	[FIELD3_DATE] [datetime] NULL,
	[FIELD4_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD4_NUMERIC] [float] NULL,
	[FIELD4_DATE] [datetime] NULL,
	[FIELD5_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD5_NUMERIC] [float] NULL,
	[FIELD5_DATE] [datetime] NULL,
	[FIELD6_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD6_NUMERIC] [float] NULL,
	[FIELD6_DATE] [datetime] NULL,
	[FIELD7_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD7_NUMERIC] [float] NULL,
	[FIELD7_DATE] [datetime] NULL,
	[FIELD8_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD8_NUMERIC] [float] NULL,
	[FIELD8_DATE] [datetime] NULL,
	[FIELD9_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD9_NUMERIC] [float] NULL,
	[FIELD9_DATE] [datetime] NULL,
	[FIELD10_TEXT] [nvarchar](255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL,
	[FIELD10_NUMERIC] [float] NULL,
	[FIELD10_DATE] [datetime] NULL
) ON [PRIMARY]
GO


ALTER TABLE [WFLIST] ADD 
	CONSTRAINT [PK_WFLIST] PRIMARY KEY CLUSTERED 
	(
		[ID_LIST] ASC
	) ON [PRIMARY]
GO

ALTER TABLE [WFLIST]  ADD  
	CONSTRAINT [FK_WFLIST_USERS] FOREIGN KEY
	(
		[ID_USER_UPDATE]
	) REFERENCES [USERS] ([ID_USER])
	ON UPDATE CASCADE
	ON DELETE SET NULL
GO


ALTER TABLE [WFLIST] CHECK CONSTRAINT [FK_WFLIST_USERS]
GO


ALTER TABLE [WFLIST]  ADD  
	CONSTRAINT [FK_WFLIST_WFPARTICIPANT] FOREIGN KEY
	(
		[ID_PARTICIPANT]
	) REFERENCES [WFPARTICIPANT] ([ID_PARTICIPANT])
	ON UPDATE CASCADE
	ON DELETE SET NULL
GO


ALTER TABLE [WFLIST] CHECK CONSTRAINT [FK_WFLIST_WFPARTICIPANT]
GO



CREATE UNIQUE INDEX [IDX_WFLIST_UNIQUE_NAME] ON [WFLIST]([NAME] ASC) ON [PRIMARY]
GO


CREATE INDEX [IDX_WFLIST_ID_PARTICIPANT] ON [WFLIST]([ID_PARTICIPANT] ASC) ON [PRIMARY]
GO



ALTER TABLE [WFLIST_ITEMS] ADD 
	CONSTRAINT [PK_WFLIST_ITEMS] PRIMARY KEY CLUSTERED 
	(
		[ID_LIST] ASC,
		[LANGUAGE] ASC,
		[DISP_ORDER] ASC
	) ON [PRIMARY]
GO



ALTER TABLE [WFLIST_ITEMS]  ADD  
	CONSTRAINT [FK_WFLIST_ITEMS_WFLIST] FOREIGN KEY
	(
		[ID_LIST]
	) REFERENCES [WFLIST] ([ID_LIST])
	ON UPDATE CASCADE
	ON DELETE CASCADE
GO


ALTER TABLE [WFLIST_ITEMS] CHECK CONSTRAINT [FK_WFLIST_ITEMS_WFLIST]
GO


/*  IMP# 3295 */

ALTER TABLE [WFACTIVITY_PARAM] DROP CONSTRAINT [PK_WFACTIVITY_PARAM]
GO

ALTER TABLE [WFACTIVITY_PARAM] ALTER COLUMN [PARAM] [nvarchar] (440) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
GO

ALTER TABLE [WFACTIVITY_PARAM] ADD 
	CONSTRAINT [PK_WFACTIVITY_PARAM] PRIMARY KEY  CLUSTERED 
	(
		[ID_PROCESS],
		[ID_ACTIVITY],
		[PARAM]
	)  ON [PRIMARY] 
GO

