/* ******************************************* */
/* WorkflowGen v5.6.2                          */
/* Update script for 5.6.1                     */
/* 03/12/2013                                  */
/* ******************************************* */

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

/*  IMP# 3349  */

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFAPPLICATION'
	AND COLUMN_NAME = 'ASSEMBLY')
ALTER TABLE [WFAPPLICATION] ADD [ASSEMBLY] [nvarchar] (1024) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO

If Not EXISTS(
	SELECT * FROM INFORMATION_SCHEMA.COLUMNS
	WHERE TABLE_NAME = 'WFAPPLICATION'
	AND COLUMN_NAME = 'CLASS')
ALTER TABLE [WFAPPLICATION] ADD [CLASS] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
GO

If Not EXISTS(SELECT * FROM WFAPPLICATION_TYPE WHERE ID_APP_TYPE = 'WCFSERVICE')
	INSERT INTO WFAPPLICATION_TYPE(ID_APP_TYPE,DESCRIPTION_FR,DESCRIPTION_EN,DISP_ORDER) SELECT N'WCFSERVICE',N'Service WCF',N'WCF Service',MAX(DISP_ORDER)+1 FROM WFAPPLICATION_TYPE
GO

If Not EXISTS(SELECT * FROM WFAPPLICATION_TYPE WHERE ID_APP_TYPE = 'ASSEMBLY')
	INSERT INTO WFAPPLICATION_TYPE(ID_APP_TYPE,DESCRIPTION_FR,DESCRIPTION_EN,DISP_ORDER) SELECT N'ASSEMBLY',N'Assembly',N'Assembly',MAX(DISP_ORDER)+1 FROM WFAPPLICATION_TYPE
GO

/*  IMP# 3360  */

ALTER TABLE [WFACTIVITY_PARAM] DROP CONSTRAINT [PK_WFACTIVITY_PARAM]
GO

ALTER TABLE [WFACTIVITY_PARAM] ALTER COLUMN [PARAM] [nvarchar] (440) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
GO

ALTER TABLE [WFACTIVITY_PARAM] ADD 
	CONSTRAINT [PK_WFACTIVITY_PARAM] PRIMARY KEY  CLUSTERED 
	(
		[ID_PROCESS],
		[ID_ACTIVITY],
		[PARAM]
	)  ON [PRIMARY] 
GO

