/* ******************************************* */
/* WorkflowGen v5.6.3                          */
/* Update script for 5.6.2                     */
/* 27/03/2014                                  */
/* ******************************************* */

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

/*  IMP# 3375  */

If Not EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'UPDATEPROCESSDATA')
BEGIN
	INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'UPDATEPROCESSDATA',N'Update process data',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'UpdateProcessInstanceDataWithContext',N'N',N'Y' FROM WFAPPLICATION
	
	DECLARE @ID_APPLICATION int;
	SET @ID_APPLICATION = (SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'UPDATEPROCESSDATA');

	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,1,N'REQUEST_ID',N'Request identifier',N'NUMERIC',N'IN',N'N',N'Y')
END
GO

If Not EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'COMPLETEACTION')
BEGIN
	INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'COMPLETEACTION',N'Complete action',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'CompleteActivityInstanceWithContext',N'N',N'Y' FROM WFAPPLICATION
	
	DECLARE @ID_APPLICATION int;
	SET @ID_APPLICATION = (SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'COMPLETEACTION');

	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,1,N'REQUEST_ID',N'Request identifier',N'NUMERIC',N'IN',N'N',N'Y')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,2,N'ACTION_ID',N'Action identifier',N'NUMERIC',N'IN',N'Y',N'N')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,3,N'ACTION_NAME',N'Action name',N'TEXT',N'IN',N'N',N'N')
END
GO

/*  IMP# 3371  */

If EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'RAISEEXCEPTION')
BEGIN
	UPDATE WFAPPLICATION
		SET ID_APP_TYPE = N'ASSEMBLY'
		  ,ENCTYPE = NULL
		  ,URL = NULL
		  ,WEBMETHOD = N'RaiseExceptionOnActivityInstanceWithContext'
		  ,CONTEXT_SCHEMA = NULL
		  ,CONTEXT_SCHEMA_EMBEDDED = NULL
		  ,USERNAME = NULL
		  ,PASSWORD = NULL
		  ,DEFAULTAPP = N'N'
		  ,ASSEMBLY = N'Advantys.Workflow.Web.Services.Processes.Runtime'
		  ,CLASS = N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService'
		WHERE NAME = N'RAISEEXCEPTION'
END
GO