/* ******************************************* */
/* WorkflowGen v5.6.4                          */
/* Update script for 5.6.3                     */
/* 27/03/2014                                  */
/* ******************************************* */

SET QUOTED_IDENTIFIER ON
GO
SET ANSI_NULLS ON
GO

/*  IMP# 3391  */

IF EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'RAISEEXCEPTION')
BEGIN
	DECLARE @ID_APPLICATION int;
	SET @ID_APPLICATION = (SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'RAISEEXCEPTION');

	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,8,N'EXCEPTION_NAME',N'Exception name',N'TEXT',N'IN',N'N',N'N')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,9,N'EXCEPTION_MESSAGE',N'Exception message',N'TEXT',N'IN',N'N',N'N')
END
GO

/*  IMP# 3392  */

IF EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'COMPLETEACTION')
BEGIN
	DECLARE @ID_APPLICATION int;
	SET @ID_APPLICATION = (SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'COMPLETEACTION');

	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,4,N'IMPERSONATE_USERNAME',N'Impersonate username',N'TEXT',N'IN',N'Y',N'N')
END
GO

/*  IMP# 3396  */

If Not EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'CANCELREQUEST')
BEGIN
	INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'CANCELREQUEST',N'Cancel request',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'CancelProcessInstanceWithContext',N'N',N'Y' FROM WFAPPLICATION
	
	DECLARE @ID_APPLICATION int;
	SET @ID_APPLICATION = (SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'CANCELREQUEST');
	
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,1,N'REQUEST_ID',N'Request identifier',N'NUMERIC',N'IN',N'N',N'Y')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,2,N'NOTIFY_PARTICIPANT',N'Notify participant',N'TEXT',N'IN',N'Y',N'N')
END
GO

If Not EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'GETPROCESSDATA')
BEGIN
	INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'GETPROCESSDATA',N'Get process data',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'GetProcessInstanceContextWithContext',N'N',N'Y' FROM WFAPPLICATION
	
	DECLARE @ID_APPLICATION int;
	SET @ID_APPLICATION = (SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'GETPROCESSDATA');
	
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,1,N'REQUEST_ID',N'Request identifier',N'NUMERIC',N'IN',N'N',N'Y')
END
GO

If Not EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'GETFORMDATA')
BEGIN
	INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'GETFORMDATA',N'Get form data',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'GetProcessInstanceFormDataWithContext',N'N',N'Y' FROM WFAPPLICATION
	
	DECLARE @ID_APPLICATION int;
	SET @ID_APPLICATION = (SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'GETFORMDATA');
	
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,1,N'REQUEST_ID',N'Request identifier',N'NUMERIC',N'IN',N'N',N'Y')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,2,N'FORM_DATA_NAME',N'Form data name',N'TEXT',N'IN',N'N',N'N')
END
GO

