/* ******************************************* */
/* WorkflowGen v6.1                            */
/* Update script for 6.0.x		                 */
/* February 4th 2016                         */
/* ******************************************* */

/* Workflow application MERGEFORM */

If Not EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'MERGEFORM')
BEGIN  
  
  DECLARE @ID_APPLICATION AS INT = (SELECT MAX(ID_APPLICATION) + 1 FROM WFAPPLICATION);  

	INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) 
  SELECT @ID_APPLICATION,MAX(DISP_ORDER) + 1,N'MERGEFORM',N'Merge form data',N'ASSEMBLY',N'Advantys.Workflow.Applications.Web.Services.MergeForm',N'Advantys.Workflow.Applications.Web.Services.MergeForm.MergeForm',N'Merge',N'N',N'Y' FROM WFAPPLICATION
	
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,1,N'FORM_DATA',N'The merge target form data',N'FILE',N'INOUT',N'N',N'Y')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,2,N'FORM_DATA_SOURCE1',N'The form data file to merge with the target form data',N'FILE',N'IN',N'N',N'Y')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,3,N'FORM_FIELDS_MERGE1',N'The fields to merge from FORM_DATA_SOURCE1 to FORM_DATA, separated by commas',N'TEXT',N'IN',N'N',N'Y')
  INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,4,N'FORM_ARCHIVE',N'The merge target form archive',N'FILE',N'INOUT',N'N',N'N')
  INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,5,N'FORM_ARCHIVE_SOURCE1',N'The form archive file to merge with the target form archive',N'FILE',N'IN',N'N',N'N')
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,6,N'FORM_FIELDS_ARCHIVE1',N'The sections to merge from FORM_ARCHIVE_SOURCE1 to FORM_ARCHIVE, separated by commas',N'TEXT',N'IN',N'N',N'N')
END
GO

/* Workflow application COPYDATA */

If Not EXISTS(SELECT * FROM WFAPPLICATION WHERE NAME = 'COPYDATA')
BEGIN  

  DECLARE @ID_APPLICATION AS INT = (SELECT MAX(ID_APPLICATION) + 1 FROM WFAPPLICATION);  

	INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) 
  SELECT @ID_APPLICATION,MAX(DISP_ORDER) + 1,N'COPYDATA',N'Copy data passed as INOUT parameters',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'CopyDataWithContext',N'N',N'Y' FROM WFAPPLICATION
	
	INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,1,N'DATA_TEXT1',N'TEXT type data to copy',N'TEXT',N'INOUT',N'N',N'N')
  INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,2,N'DATA_FILE1',N'FILE type data to copy',N'FILE',N'INOUT',N'N',N'N')
  INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,3,N'DATA_NUMERIC1',N'NUMERIC type data to copy',N'NUMERIC',N'INOUT',N'N',N'N')
  INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,[DEFAULT],[REQUIRED]) VALUES (@ID_APPLICATION,4,N'DATA_DATETIME1',N'DATETIME type data to copy',N'DATETIME',N'INOUT',N'N',N'N')

END
GO

