/* ******************************************* */
/* WorkflowGen v5.2                            */
/* Update script for 5.0 and 5.1               */
/* June 23rd 2010                              */
/* ******************************************* */


alter table WFDATASET add (STOREINDB NVARCHAR2(1));

alter table WFDATASET_VALUE add (VALUE_FILE_CONTENT BLOB);

alter table WFPROCESS add (RELDATA_STOREINDB NVARCHAR2(1));

alter table WFPROCESS_PARTICIPANT add (DATASOURCE_QUERY NVARCHAR2(2000));

INSERT INTO WFNOTIFY_TYPE (ID_NOTIFY_TYPE,DESCRIPTION_FR,DESCRIPTION_EN,DISP_ORDER) VALUES (N'prior_overdue',N'Pr-retard',N'Prior overdue',6);

UPDATE WFNOTIFY_TYPE SET DISP_ORDER=7 WHERE ID_NOTIFY_TYPE='closed';

UPDATE WFNOTIFY_TYPE SET DISP_ORDER=8 WHERE ID_NOTIFY_TYPE='error';

alter table WFPROCESS_PARTICIPANT add (COMMENTS_PERMISSIONS NVARCHAR2(5));

/*==============================================================*/
/* Table : WFPROCESS_INST_COMMENT                               */
/*==============================================================*/

create table WFPROCESS_INST_COMMENT (
    ID_PROCESS_INST        INTEGER                    not null,
    NUM_COMMENT            INTEGER                    not null,
    ID_USER_AUTHOR         INTEGER                    not null,
    DATE_POST              DATE,
    MESSAGE                NVARCHAR2(2000),
    TAG                    NVARCHAR2(2000),
    GEOLOC_LATITUDE        FLOAT,
    GEOLOC_LONGITUDE       FLOAT,
    GEOLOC_ALTITUDE        FLOAT,
    constraint PK_WFPROCESS_INST_COMMENT primary key (ID_PROCESS_INST, NUM_COMMENT),
    constraint FK_PROC_INS_COM_REF_PROC_INS foreign key (ID_PROCESS_INST)
        references WFPROCESS_INST (ID_PROCESS_INST)
        on delete cascade,
    constraint FK_PROC_INS_COM_REF_USERS foreign key (ID_USER_AUTHOR)
        references USERS (ID_USER)
        on delete cascade
); 


/*==============================================================*/
/* Index : IDX_USERS_WFPROC_INS_COM                             */
/*==============================================================*/


create index IDX_USERS_WFPROC_INS_COM on WFPROCESS_INST_COMMENT (
    ID_USER_AUTHOR ASC
);


/*==============================================================*/
/* Index : IDX_NUM_WFPROC_INS_COM                               */
/*==============================================================*/


create index IDX_NUM_WFPROC_INS_COM on WFPROCESS_INST_COMMENT (
    NUM_COMMENT ASC
);


/*==============================================================*/
/* Index : IDX_ID_WFPROC_INS_COM                                */
/*==============================================================*/


create index IDX_ID_WFPROC_INS_COM on WFPROCESS_INST_COMMENT (
    ID_PROCESS_INST ASC
);


update WFPROCESS_PARTICIPANT set COMMENTS_PERMISSIONS = N'RW' where ID_PARTICIPANT_ROLE = N'SUPERVISOR';

alter table GROUPS modify (DATASOURCE_QUERY NVARCHAR2(2000));

alter table WFPROCESS_PARTICIPANT modify (DATASOURCE_QUERY NVARCHAR2(2000));