/* ******************************************* */
/* WorkflowGen v5.6.0                          */
/* Update script for 5.5.5                     */
/* 03/12/2013                                  */
/* ******************************************* */

/*  IMP# 3286  */

alter table WFACTIVITY add (COMPLETE_ASYNC NVARCHAR2(1));

/*  IMP# 3173  */


/*==============================================================*/
/* Table : WFLIST                                               */
/*==============================================================*/


create table WFLIST  (
    ID_LIST             INTEGER                         not null,
    NAME                NVARCHAR2(255)                  not null,
    ID_PARTICIPANT      INTEGER,
    DATE_UPDATE         DATE                            not null,
    ID_USER_UPDATE      INTEGER,
    NB_ITEMS            INTEGER                         not null,
    FIELD1_NAME         NVARCHAR2(255),
    FIELD1_TYPE         NVARCHAR2(50),
    FIELD2_NAME         NVARCHAR2(255),
    FIELD2_TYPE         NVARCHAR2(50),
    FIELD3_NAME         NVARCHAR2(255),
    FIELD3_TYPE         NVARCHAR2(50),
    FIELD4_NAME         NVARCHAR2(255),
    FIELD4_TYPE         NVARCHAR2(50),
    FIELD5_NAME         NVARCHAR2(255),
    FIELD5_TYPE         NVARCHAR2(50),
    FIELD6_NAME         NVARCHAR2(255),
    FIELD6_TYPE         NVARCHAR2(50),
    FIELD7_NAME         NVARCHAR2(255),
    FIELD7_TYPE         NVARCHAR2(50),
    FIELD8_NAME         NVARCHAR2(255),
    FIELD8_TYPE         NVARCHAR2(50),
    FIELD9_NAME         NVARCHAR2(255),
    FIELD9_TYPE         NVARCHAR2(50),
    FIELD10_NAME        NVARCHAR2(255),
    FIELD10_TYPE        NVARCHAR2(50),
    FIELDS_ALL_NAME     CLOB,
    CONNECTION_MODE     NVARCHAR2(64),
    CONNECTION_NAME     NVARCHAR2(64),
    CONNECTION_STRING   NVARCHAR2(500),
    PROVIDER_NAME       NVARCHAR2(64),
    SELECT_COMMAND      CLOB,
    constraint PK_WFLIST primary key (ID_LIST),   
    constraint FK_WFLIST_USERS foreign key (ID_USER_UPDATE)
        references USERS (ID_USER)
        on delete set null,
    constraint FK_WFLIST_WFPARTICIPANT foreign key (ID_PARTICIPANT)
        references WFPARTICIPANT (ID_PARTICIPANT)
        on delete set null
);

 
/*==============================================================*/
/* Table : WFLIST_ITEMS                                         */
/*==============================================================*/
 
 create table WFLIST_ITEMS  (
    ID_LIST         INTEGER                         not null,
    LANGUAGE        NVARCHAR2(7)                    not null,
    DISP_ORDER      INTEGER                         not null,
    FIELD1_TEXT     NVARCHAR2(255),
    FIELD1_NUMERIC  FLOAT,
    FIELD1_DATE     DATE,
    FIELD2_TEXT     NVARCHAR2(255),
    FIELD2_NUMERIC  FLOAT,
    FIELD2_DATE     DATE,
    FIELD3_TEXT     NVARCHAR2(255),
    FIELD3_NUMERIC  FLOAT,
    FIELD3_DATE     DATE,
    FIELD4_TEXT     NVARCHAR2(255),
    FIELD4_NUMERIC  FLOAT,
    FIELD4_DATE     DATE,
    FIELD5_TEXT     NVARCHAR2(255),
    FIELD5_NUMERIC  FLOAT,
    FIELD5_DATE     DATE,
    FIELD6_TEXT     NVARCHAR2(255),
    FIELD6_NUMERIC  FLOAT,
    FIELD6_DATE     DATE,
    FIELD7_TEXT     NVARCHAR2(255),
    FIELD7_NUMERIC  FLOAT,
    FIELD7_DATE     DATE,
    FIELD8_TEXT     NVARCHAR2(255),
    FIELD8_NUMERIC  FLOAT,
    FIELD8_DATE     DATE,
    FIELD9_TEXT     NVARCHAR2(255),
    FIELD9_NUMERIC  FLOAT,
    FIELD9_DATE     DATE,
    FIELD10_TEXT    NVARCHAR2(255), 
    FIELD10_NUMERIC FLOAT,
    FIELD10_DATE    DATE,
    constraint PK_WFLIST_ITEMS primary key (ID_LIST, LANGUAGE, DISP_ORDER),   
    constraint FK_WFLIST_ITEMS_WFLIST foreign key (ID_LIST)
        references WFLIST (ID_LIST)
        on delete cascade
);



/*==============================================================*/
/* Index : IDX_WFLIST_UNIQUE_NAME                       */
/*==============================================================*/

create unique index IDX_WFLIST_UNIQUE_NAME on WFLIST (
   NAME ASC
);


/*==============================================================*/
/* Index : IDX_WFLIST_ID_PARTICIPANT                       */
/*==============================================================*/

create index IDX_WFLIST_ID_PARTICIPANT on WFLIST (
   ID_PARTICIPANT ASC
);


/*  IMP# 3295 */

alter table WFACTIVITY_PARAM modify (PARAM NVARCHAR2(440));


