/* ******************************************* */
/* WorkflowGen v6.1                            */
/* Update script for 6.0.x		               */
/* September 14th 2015                         */
/* ******************************************* */

/* Add column SALT to USERS table */

ALTER TABLE USERS
ADD SALT nvarchar2(64);

/* Add column CONN_ATTEMPTS to USERS table */

ALTER TABLE USERS
ADD CONN_ATTEMPTS INTEGER DEFAULT 0 NULL;

/* Add column RESETPWD_TOKEN to USERS table */

ALTER TABLE USERS
ADD RESETPWD_TOKEN nvarchar2(255);

/* Add column RESETPWD_TIME to USERS table */

ALTER TABLE USERS
ADD RESETPWD_TIME DATE;

/* Delete constraint on WFPROCESS_INST_RELDATA with foreign key reference to WFDATASET.ID_DATASET */

alter table WFPROCESS_INST_RELDATA add constraint FK_WFPROCES_REFEREN_WFDATASET foreign key (ID_DATASET)
         references WFDATASET (ID_DATASET)
         on delete cascade;
		 
/* Workflow application STARTPROCESS */

INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) 
SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'STARTPROCESS',N'Start process',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'StartProcessWithContext',N'N',N'Y' FROM WFAPPLICATION;
	
INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT","REQUIRED") 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'STARTPROCESS'),1,N'PROCESS_ID',N'Process identifier',N'NUMERIC',N'IN',N'Y',N'N');
	
INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT","REQUIRED") 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'STARTPROCESS'),2,N'PROCESS_NAME',N'Process name',N'TEXT',N'IN',N'Y',N'N');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT","REQUIRED") 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'STARTPROCESS'),3,N'PROCESS_VERSION',N'Process version',N'NUMERIC',N'IN',N'Y',N'N');
	
INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT","REQUIRED") 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'STARTPROCESS'),4,N'TEST',N'Test',N'TEXT',N'IN',N'Y',N'N');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT","REQUIRED") 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'STARTPROCESS'),5,N'IMPERSONATE_USERNAME',N'Impersonate username',N'TEXT',N'IN',N'Y',N'N');
	
INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT","REQUIRED") 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'STARTPROCESS'),6,N'REQUEST_ID',N'Request identifier',N'NUMERIC',N'OUT',N'Y',N'N');