/* ******************************************* */
/* WorkflowGen v6.1.4                          */
/* Update script for 6.1.3 and earlier         */
/* October 14, 2016                            */
/* ******************************************* */
		 
/* Clean-up of WFPARTICIPANT_MAPTO to remove zombie records still referencing to invalid ID_USER, ID_GROUP and ID_DIRECTORY */
		 
delete from wfparticipant_mapto where id_user is not null and id_user not in (select id_user from users);

delete from wfparticipant_mapto where id_group is not null and id_group not in (select id_group from groups);

delete from wfparticipant_mapto where id_directory is not null and id_directory not in (select id_directory from directory);

/* Delete constraint on WFPARTICIPANT_MAPTO with foreign key reference to USERS.ID_USER */

alter table WFPARTICIPANT_MAPTO add constraint FK_WFPAR_MAPTO_REF_USERS foreign key (ID_USER)
         references USERS (ID_USER)
         on delete cascade;
		 
/* Delete constraint on WFPARTICIPANT_MAPTO with foreign key reference to GROUPS.ID_GROUP */

alter table WFPARTICIPANT_MAPTO add constraint FK_WFPAR_MAPTO_REF_GROUPS foreign key (ID_GROUP)
         references GROUPS (ID_GROUP)
         on delete cascade;
		
/* Delete constraint on WFPARTICIPANT_MAPTO with foreign key reference to DIRECTORY.ID_DIRECTORY */

alter table WFPARTICIPANT_MAPTO add constraint FK_WFPAR_MAPTO_REF_DIR foreign key (ID_DIRECTORY)
         references DIRECTORY (ID_DIRECTORY)
         on delete cascade;
		 
/* Workflow application MERGEFORM */

INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) 
SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'MERGEFORM',N'Merge form data',N'ASSEMBLY',N'Advantys.Workflow.Applications.Web.Services.MergeForm',N'Advantys.Workflow.Applications.Web.Services.MergeForm.MergeForm',N'Merge',N'N',N'Y' FROM WFAPPLICATION;

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'MERGEFORM'),1,N'FORM_DATA',N'The merge target form data',N'FILE',N'INOUT',N'N',N'Y');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'MERGEFORM'),2,N'FORM_DATA_SOURCE1',N'The form data file to merge with the target form data',N'FILE',N'IN',N'N',N'Y');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'MERGEFORM'),3,N'FORM_FIELDS_MERGE1',N'The fields to merge from FORM_DATA_SOURCE1 to FORM_DATA, separated by commas',N'TEXT',N'IN',N'N',N'Y');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'MERGEFORM'),4,N'FORM_ARCHIVE',N'The merge target form archive',N'FILE',N'INOUT',N'N',N'N');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'MERGEFORM'),5,N'FORM_ARCHIVE_SOURCE1',N'The form archive file to merge with the target form archive',N'FILE',N'IN',N'N',N'N');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'MERGEFORM'),6,N'FORM_FIELDS_ARCHIVE1',N'The sections to merge from FORM_ARCHIVE_SOURCE1 to FORM_ARCHIVE, separated by commas',N'TEXT',N'IN',N'N',N'N');

/* Workflow application COPYDATA */

INSERT INTO WFAPPLICATION(ID_APPLICATION,DISP_ORDER,NAME,DESCRIPTION,ID_APP_TYPE,ASSEMBLY,CLASS,WEBMETHOD,DEFAULTAPP,ACTIVE) 
SELECT MAX(ID_APPLICATION)+1,MAX(DISP_ORDER)+1,N'COPYDATA',N'Copy data passed as INOUT parameters',N'ASSEMBLY',N'Advantys.Workflow.Web.Services.Processes.Runtime',N'Advantys.Workflow.Web.Services.Processes.Runtime.RuntimeService',N'CopyDataWithContext',N'N',N'Y' FROM WFAPPLICATION;

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'COPYDATA'),1,N'DATA_TEXT1',N'Data of type TEXT to copy',N'TEXT',N'INOUT',N'N',N'N');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'COPYDATA'),2,N'DATA_FILE1',N'Data of type FILE to copy',N'FILE',N'INOUT',N'N',N'N');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'COPYDATA'),3,N'DATA_NUMERIC1',N'Data of type NUMERIC to copy',N'NUMERIC',N'INOUT',N'N',N'N');

INSERT INTO WFAPPLICATION_PARAM(ID_APPLICATION,NUM_PARAM,NAME,DESCRIPTION,ID_DATATYPE,DIRECTION,"DEFAULT",REQUIRED) 
VALUES ((SELECT ID_APPLICATION FROM WFAPPLICATION WHERE WFAPPLICATION.NAME = N'COPYDATA'),4,N'DATA_DATETIME1',N'Data of type DATETIME to copy',N'DATETIME',N'INOUT',N'N',N'N');
