/* ******************************************* */
/* WorkflowGen v7.2.0                          */
/* Update script for 7.1.0		               */
/* March 8 2017                                */
/* ******************************************* */

/* Update web service workflow apps */

UPDATE WFAPPLICATION
SET ASSEMBLY = 'Advantys.Workflow.Applications.GetUsersFromDir',
CLASS = 'Advantys.Workflow.Applications.GetUsersFromDir.GetUsersFromDirService'
WHERE NAME='GETUSERSFROMDIR';

UPDATE WFAPPLICATION
SET ASSEMBLY = 'Advantys.Workflow.Applications.MergeForm',
CLASS = 'Advantys.Workflow.Applications.MergeForm.MergeForm'
WHERE NAME='MERGEFORM';

UPDATE WFAPPLICATION
SET ASSEMBLY = 'Advantys.Workflow.Applications.XmlToDatabase',
CLASS = 'Advantys.Workflow.Applications.XmlToDatabase.XmlToDatabaseService'
WHERE NAME='XMLTODATABASE';

UPDATE WFAPPLICATION
SET ASSEMBLY = 'Advantys.Workflow.Applications.XmlTrans',
CLASS = 'Advantys.Workflow.Applications.XmlTrans.XmlTransService'
WHERE NAME='XMLTRANS';

/* Tables creation for the Favorites section */
create table FAVORITE_TYPE (
   ID_FAVORITE_TYPE     NVARCHAR2(64)			not null,
   DESCRIPTION		    NVARCHAR2(255),

   constraint PK_FAVORITE_TYPE primary key (ID_FAVORITE_TYPE)
);

create table FAVORITE (
   ID_FAVORITE			INTEGER					not null,
   ID_USER_FAVORITE		INTEGER					not null,
   ID_FAVORITE_TYPE     NVARCHAR2(64)			not null,
   DESCRIPTION		    NVARCHAR2(255),
   ID_PROCESS			INTEGER,
   ID_USER				INTEGER,
   NUM_VIEW				INTEGER,

   constraint PK_FAVORITE primary key (ID_FAVORITE),
   constraint FK_FAVORITE_REF_FAVORITE_TYPE foreign key (ID_FAVORITE_TYPE)
         references FAVORITE_TYPE (ID_FAVORITE_TYPE)
         on delete cascade,
   constraint FK_FAVORITE_REF_WFPROCESS foreign key (ID_PROCESS)
         references WFPROCESS (ID_PROCESS)
         on delete cascade,
   constraint FK_FAVORITE_REF_USERS_VIEWS foreign key (ID_USER,NUM_VIEW)
		 references USERS_VIEWS (ID_USER,NUM_VIEW)
		 on delete cascade,
   constraint FK_FAVORITE_REF_USERS foreign key (ID_USER_FAVORITE)
		 references USERS (ID_USER)
		 on delete cascade
);

/* FAVORITE_TYPE */
DELETE FROM FAVORITE_TYPE;
INSERT INTO FAVORITE_TYPE(ID_FAVORITE_TYPE,DESCRIPTION) VALUES('PROCESS','FAVORITE PROCESS');
INSERT INTO FAVORITE_TYPE(ID_FAVORITE_TYPE,DESCRIPTION) VALUES('VIEW','FAVORITE VIEW');
