/**
 * activity.js
 * GraphQL resolvers
 */
'use strict';

const activityResolveFunctions = {
  Activity: {
    process(activity, args, context) {
      context.incrementResolverCount();
      if (activity.userId) {
        args.userId = activity.userId;
      }
      if (activity.onBehalfOf) {
        args.onBehalfOf = activity.onBehalfOf;
      }
      args.id = activity.processId;
      return context.loaders.operations.load({operation: 'getProcess', args: args});
    }
  }
};

module.exports = activityResolveFunctions;
