/**
 * category.js
 * GraphQL resolvers
 */
'use strict';

const categoryResolveFunctions = {
  Category: {
    processes(category, args, context) {
      context.incrementResolverCount();
      if (category.userId) {
        args.userId = category.userId;
      }
      if (category.onBehalfOf) {
        args.onBehalfOf = category.onBehalfOf;
      }
      args.filter = { categoryId: category.id};
      return context.workflow.service.invoke('getProcesses', context.workflow.context, args);
    },
    launchableProcesses(category, args, context) {
      context.incrementResolverCount();
      if (category.userId) {
        args.userId = category.userId;
      }
      if (category.onBehalfOf) {
        args.onBehalfOf = category.onBehalfOf;
      }
      args.filter = {categoryId: category.id};
      return context.workflow.service.invoke('getLaunchableProcesses', context.workflow.context, args);
    }
  }
};

module.exports = categoryResolveFunctions;
