/**
 * mutation.js
 * GraphQL resolvers
 */
'use strict';

const mutationResolveFunctions = {

 Mutation: {
    createRequest(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('createRequest', context.workflow.context, args);
    },
    cancelRequest(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('cancelRequest', context.workflow.context, args);
    },
    completeAction(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('completeAction', context.workflow.context, args);
    },
    assignAction(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('assignAction', context.workflow.context, args);
    },
    cancelActionAssignment(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('cancelActionAssignment', context.workflow.context, args);
    },
    cancelAction(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('cancelAction', context.workflow.context, args);
    },
    cancelActions(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('cancelActions', context.workflow.context, args);
    },
    createDelegation(root, args, context){
      context.incrementResolverCount();
      return context.workflow.service.invoke('createDelegation', context.workflow.context, args);
    },
    deleteDelegation(roor, args, context){
      context.incrementResolverCount();
      return context.workflow.service.invoke('deleteDelegation', context.workflow.context, args);
    },
    updateDelegation(roor, args, context){
      context.incrementResolverCount();
      return context.workflow.service.invoke('updateDelegation', context.workflow.context, args);
    },
    addComment(root, args, context){
      context.incrementResolverCount();
      return context.workflow.service.invoke('addComment', context.workflow.context, args);  
    },
    removeComment(root, args, context){
      context.incrementResolverCount();
      return context.workflow.service.invoke('removeComment', context.workflow.context, args);  
    },
    updateRequestDataset(root, args, context) {
      context.incrementResolverCount();
      return context.workflow.service.invoke('updateRequestDataset', context.workflow.context, args);
    }
  }

};

module.exports = mutationResolveFunctions;
