/**
 * mutation.js
 * GraphQL Type definitions using schema language
 */
'use strict';

const mutationTypeDefs = `

# the schema allows the following mutation:
type Mutation {

  # Creates a new a request.
  createRequest (input: CreateRequestInput): CreateRequestResult

  # Cancels a request.
  cancelRequest (input: CancelRequestInput): CancelRequestResult
  
  # Completes an action.
  completeAction (input: CompleteActionInput): CompleteActionResult

  # Assigns an action.
  assignAction (input: AssignActionInput): AssignActionResult

  # Cancels an action assignment
  cancelActionAssignment (input: CancelActionAssignmentInput): CancelActionAssignmentResult

  # Cancels an action.
  cancelAction (input: CancelActionInput): CancelActionResult

  # Cancels actions by name.
  cancelActions (input: CancelActionsInput): CancelActionsResult
  
  # Creates a delegation.
  createDelegation (input: CreateDelegationInput): CreateDelegationResult

  # Updates a delegation.
  updateDelegation (input: UpdateDelegationInput): UpdateDelegationResult

  # Deletes a delegation.
  deleteDelegation (input: DeleteDelegationInput): DeleteDelegationResult

  # Adds a new comment.
  addComment (input: AddCommentInput): AddCommentResult

  # Removes a comment.
  removeComment (input: RemoveCommentInput): RemoveCommentResult  

  # Updates request dataset.
  updateRequestDataset (input: UpdateRequestDatasetInput): UpdateRequestDatasetResult

}

`;

module.exports = mutationTypeDefs;
