//Insert favorite in the database
function insertFavoriteInDatabase(favoriteIcon,isView,idUserFavorite, idProcess, numView, idUser, isHomePage)
{	
	if(isProcessingFavorite == false)
		{

			//Processing starts
			isProcessingFavorite = true;
			$('html, body').css("cursor", "wait");

			//Get parameters
			var data = "";
			var str = strUrlInsertFavorite + '&IS_VIEW=' + isView + '&ID_USER_FAVORITE=' + idUserFavorite + '&ID_PROCESS=' + idProcess + '&NUM_VIEW=' + numView + '&ID_USER=' + idUser;
			
			//To test the CSRF protection
			
			/*var start = str.indexOf('&WFGEN_CSRF_TOKEN');
			var end = str.indexOf('&IS_VIEW');
			
			str = str.substr(0, start) + str.substr(end);*/
			 

			//Ajax call
			$.ajax({
				url: str,
				data: data,
				type: "POST",
				async: true,
				success: function() {
					if(isHomePage == true)
					{
						addViewOrProcessToFavorite (favoriteIcon, isView, idUserFavorite, idProcess, numView, idUser); 
					}
					else
					{
						//This condition allows the list table on the View page to display correctly with favorites
						if(isView == true)
						{
							document.getElementById(favoriteIcon.id).parentNode.classList.remove('FavoriteViewDescription');
						}

						//Change favorite icon onclick event 
						document.getElementById(favoriteIcon.id).onclick = function(){
							removeFavoriteFromDatabase(document.getElementById(favoriteIcon.id),isView, idUserFavorite, idProcess, numView, idUser, false); 
						}

						//Change favorite icon appearance
						document.getElementById(favoriteIcon.id).src = '../wfgen/App_Themes/Default/portal/images/favorites.svg';
						document.getElementById(favoriteIcon.id).className = 'Icon IconFavoriteSelected';
						document.getElementById(favoriteIcon.id).title = removeFavoriteToolTip;

						//Processing finishes
						$('html, body').css("cursor", "auto");
						isProcessingFavorite = false;
					}
				
				},
				//On error, the message is displayed in an alert and the processing finishes
				error: function(xhr, status, error) {
					var response = xhr.responseText;
					$('html, body').css("cursor", "auto");
					isProcessingFavorite = false;
					if($(response).filter('title').text() != "")
					{
						alert($(response).filter('title').text(),"Error");
					}
					else
					{
						alert("An unexpected error has occurred while adding a new favorite.","Error");
					}
				}
			});
		}
	}

// Add view or process to favorites 
function addViewOrProcessToFavorite(favoriteIcon, isView, idUserFavorite, idProcess, numView, idUser) 
{
	//If there is no favorite, the section is hidden 
	if($("#FavoriteList").css('display')=='none' && $("#FAVORITE_LIST").css('display')=='none')
	{
		$("#FavoriteList").show();
		$("#FAVORITE_LIST").show();
	}

	//Get the row to be inserted
	var row = favoriteIcon.parentNode.parentNode;
	var buttonId = favoriteIcon.id;

	//If the newly inserted favorite is a view
	if(isView==true)
	{
		//Display the favorite views table
		if($("#ViewsTableHeader").css('display')=='none' )
		{
			$("#ViewsTableHeader").show(); 
		}
		
		//Create the new row in the favorite views table
		var table = document.getElementById('ViewsTable');
        var newRow =  table.insertRow(-1);
        newRow.className ='Row';

		//Change favorite icon id in the new row to avoid id conflicts
		buttonId = buttonId.replace("MyView","MyFavorite_View");
			 
		//Add mouseover and mouseout events to the new row	 
		newRow.addEventListener("mouseover",function(){
			this.className = 'RowHighLight'; 
			document.getElementById(buttonId).style.display = 'inline';
		});
        newRow.addEventListener("mouseout",function(){
			this.className = 'Row';
			document.getElementById(buttonId).style.display = 'none';
		});

		//Insert the cell
        var cell =  newRow.insertCell(0);
		var innerHtml = row.innerHTML;
		innerHtml = innerHtml.replace(/id="MyView_/g,'id="MyFavorite_View_');
        cell.innerHTML = innerHtml;
        cell.className = 'CellTextAlternate';
		
		//Sort the table alphabetically
		sortTable('#ViewsTable','#ViewsTableHeader');
		
		//Change the favorite icon in new row
        document.getElementById(buttonId).src = '../wfgen/App_Themes/Default/portal/images/favorites.svg';
		document.getElementById(buttonId).style.display = 'none';

		//Change the onclick event to the new row favorite icon
		document.getElementById(buttonId).removeAttribute("onclick");
		document.getElementById(buttonId).title = removeFavoriteToolTip;
		document.getElementById(buttonId).onclick = function(){
			removeFavoriteFromDatabase(document.getElementById(buttonId),true, idUserFavorite, idProcess, numView, idUser, true);
		};

		//Change the icon onclick event on the selected row in My views table
		document.getElementById(favoriteIcon.id).onclick = function(){
			removeFavoriteFromDatabase(document.getElementById(buttonId),true, idUserFavorite, idProcess, numView, idUser, true);
		};
		
		//Change the icon appearance on the selected row in My views table
		document.getElementById(favoriteIcon.id).src = '../wfgen/App_Themes/Default/portal/images/favorites.svg';
		document.getElementById(favoriteIcon.id).className = 'Icon IconFavoriteSelected';		
		document.getElementById(favoriteIcon.id).title = removeFavoriteToolTip;
	}
	
    else
	{
		//Display the favorite processes table
		if($("#ProcessesTableHeader").css('display')=='none')
		{
			$("#ProcessesTableHeader").show();
		}

		//Create the new row in the favorite processes table
        var table = document.getElementById('ProcessesTable');
        var newRow =  table.insertRow(-1);
        newRow.className ='Row';

		//Change favorite icon id in the new row to avoid id conflicts
		buttonId = buttonId.replace("NewRequest","MyFavorite_Process");

		//Add mouseover and mouseout events to the new row	 
		newRow.addEventListener("mouseover",function(){
			this.className = 'RowHighLight'; 
			document.getElementById(buttonId).style.display = 'inline';
		});
        newRow.addEventListener("mouseout",function(){
			this.className = 'Row';
			document.getElementById(buttonId).style.display = 'none';
		});

		//Insert the cell
        var cell =  newRow.insertCell(0);
		var innerHtml = row.innerHTML;
		innerHtml = innerHtml.replace(/id="NewRequest_/g,'id="MyFavorite_Process_');
        cell.innerHTML = innerHtml;
        cell.className = 'CellTextAlternate';
		
		//Sort the table alphabetically
		sortTable('#ProcessesTable','#ProcessesTableHeader');

		//Change the favorite icon in new row
        document.getElementById(buttonId).src = '../wfgen/App_Themes/Default/portal/images/favorites.svg';
		document.getElementById(buttonId).style.display = 'none';

		//Change the onclick event to the new row favorite icon
		document.getElementById(buttonId).removeAttribute("onclick");
		document.getElementById(buttonId).title = removeFavoriteToolTip;
		 document.getElementById(buttonId).onclick = function(){
			removeFavoriteFromDatabase(document.getElementById(buttonId),false, idUserFavorite, idProcess, numView, idUser, true);
		};
		
		//Change the icon onclick event on the selected row in New Request table
		document.getElementById(favoriteIcon.id).onclick = function(){
			removeFavoriteFromDatabase(document.getElementById(buttonId),false, idUserFavorite, idProcess, numView, idUser, true); 
		};

		//Change the icon appearance on the selected row in New Request table
		document.getElementById(favoriteIcon.id).src = '../wfgen/App_Themes/Default/portal/images/favorites.svg';
		document.getElementById(favoriteIcon.id).className = 'Icon IconFavoriteSelected';
		document.getElementById(favoriteIcon.id).title = removeFavoriteToolTip;
	}       
	
	//Finish the action processing
	$('html, body').css("cursor", "auto");
	isProcessingFavorite = false;
}

//Remove a favorite from the database
function removeFavoriteFromDatabase(favoriteIcon,isView,idUserFavorite, idProcess, numView, idUser, isHomePage)
{	
	if(isProcessingFavorite == false)
	{
		//Processing starts
		isProcessingFavorite = true;
		$('html, body').css("cursor", "wait");
			
		//Get the parameters	
		var data = "";
		var str = strUrlRemoveFavorite + '&IS_VIEW=' + isView + '&ID_USER_FAVORITE=' + idUserFavorite + '&ID_PROCESS=' + idProcess + '&NUM_VIEW=' + numView + '&ID_USER=' + idUser;
			
		//To test the CSRF protection
		/*  var start = str.indexOf('&WFGEN_CSRF_TOKEN');
		var end = str.indexOf('&IS_VIEW');
		str = str.substr(0, start) + str.substr(end);  */
			
		//Ajax call
		$.ajax({
			url: str,
			data: data,
			type: "POST",
			async: true,
			success: function() {
				if(isHomePage==true)
				{
					removeViewOrProcessFromFavorite (favoriteIcon, isView, idUserFavorite, idProcess, numView, idUser);
				}
				else
				{
					//Change the icon onclick event
					document.getElementById(favoriteIcon.id).onclick = function(){
					insertFavoriteInDatabase(document.getElementById(favoriteIcon.id),isView, idUserFavorite, idProcess, numView, idUser, false);
					}

					//Change the icon appearance
					document.getElementById(favoriteIcon.id).src = '../wfgen/App_Themes/Default/portal/images/favorites_empty.svg';
					document.getElementById(favoriteIcon.id).classList.remove('IconFavoriteSelected');
					document.getElementById(favoriteIcon.id).parentNode.className = 'Label FavoriteViewDescription';
					document.getElementById(favoriteIcon.id).className = 'Icon IconFavorite';
					document.getElementById(favoriteIcon.id).title = addFavoriteToolTip;

					//Processing finishes
					$('html, body').css("cursor", "auto");
					isProcessingFavorite = false;
				}
			},
			//On error, the message is displayed in an alert and the processing finishes
			error: function(xhr, status, error) {
					var response = xhr.responseText;
					$('html, body').css("cursor", "auto");
					isProcessingFavorite = false;
					if($(response).filter('title').text() != "")
					{
						alert($(response).filter('title').text(),"Error");
					}
					else
					{
						alert("An unexpected error has occurred while removing a favorite.","Error");
					}
					
				}
			});
		}
	}

// Remove favorite view or process
function removeViewOrProcessFromFavorite(favoriteIcon, isView, idUserFavorite, idProcess, numView, idUser) {
	
	//Remove the selected row in the favorite table
	var row = favoriteIcon.parentNode.parentNode.parentNode;
	row.parentNode.removeChild(row);

	var id = favoriteIcon.id;

	//If after the removal there is no favorite, the My favorite section hides
	if(($('#ViewsTable tbody tr.Row').length < 2) && ($('#ProcessesTable tbody tr.Row').length < 2))
	{
		$("#FavoriteList").hide();
		$("#FAVORITE_LIST").hide();
		
	}

	if(isView==true)
	{
		//If after the removal there is no favorite, the Favorite views table hides
		if($('#ViewsTable tbody tr.Row').length < 2)
        {
			$("#ViewsTableHeader").hide();
        }
		
		//Get the favorite icon id in the My views table
		id = id.replace("MyFavorite_View","MyView");

		if(document.getElementById(id) != null)
		{
			//Change the favorite icon appearance
			document.getElementById(id).src = '../wfgen/App_Themes/Default/portal/images/favorites_empty.svg';
			document.getElementById(id).className = 'Icon IconFavorite';
			document.getElementById(id).classList.remove('IconFavoriteSelected'); 
			document.getElementById(id).title = addFavoriteToolTip;

			//Change the favorite icon onclick event
			document.getElementById(id).onclick = function(){
				insertFavoriteInDatabase(document.getElementById(id),true, idUserFavorite, idProcess, numView, idUser, true)
			};
		}

		//Processing finishes
		$('html, body').css("cursor", "auto");
		isProcessingFavorite = false;
	}
	else
	{
		//If after the removal there is no favorite, the Favorite processes table hides
		if($('#ProcessesTable tbody tr.Row').length < 2)
        {
			$("#ProcessesTableHeader").hide();
        }

		//Get the favorite icon id in the New request table
		id = id.replace("MyFavorite_Process","NewRequest");

		if(document.getElementById(id) != null)
		{
			//Change the favorite icon appearance
			document.getElementById(id).className = 'Icon IconFavorite';
			document.getElementById(id).classList.remove('IconFavoriteSelected');
			document.getElementById(id).src = '../wfgen/App_Themes/Default/portal/images/favorites_empty.svg';
			document.getElementById(id).title = addFavoriteToolTip;

			//Change the favorite icon onclick event
			document.getElementById(id).onclick = function(){
				insertFavoriteInDatabase(document.getElementById(id),false, idUserFavorite, idProcess, numView, idUser, true);
			};
		}
		//Processing finishes
		$('html, body').css("cursor", "auto");
		isProcessingFavorite = false;
	}
}

//Sort tables alphabetically
function sortTable(tableId, tableHeaderId)
{
	var table  = $(tableId);
		rows   = $('tr', table).not(tableHeaderId);
		rows.sort(function(a, b) {
			var keyA = $('td',a).text().toLowerCase();
			var keyB = $('td',b).text().toLowerCase();
			if(keyA > keyB) return 1;
			if(keyA < keyB) return -1;
			return 0;
		}); 
		rows.each(function(index, row) {
			table.append(row);
		});
}